//**************************************************************
// QUAD RUNNER
//**************************************************************

datablock ParticleData(QRContrailParticle) : ContrailParticle
{
   lifetimeMS = 4000;
   colors[0] = "0.6 0.1 0.1 0.5";
   colors[1] = "0.2 0.0 0.0 0";
};

datablock ParticleData(QRTwoContrailParticle) : ContrailParticle
{
   lifetimeMS = 4000;
   colors[0] = "0.1 0.1 0.6 0.5";
   colors[1] = "0.0 0.0 0.2 0";
};

datablock ParticleEmitterData(QuadRunnerContrail) : ContrailEmitter
{
   particles = "QRContrailParticle";
};

datablock ParticleEmitterData(QuadRunnerTwoContrail) : ContrailEmitter
{
   particles = "QRTwoContrailParticle";
};

datablock FlyingVehicleData(QuadRunner) : ScoutFlyer
{
   shapeFile = "quad_runner.dts";
   explosion = LargeAirVehicleExplosion;
   debrisShapeName = "quad_runner_debris.dts";
   maxDamage = 3.0;
   destroyedLevel = 3.0;
   energyPerDamagePoint = 140;
   rechargeRate = 0.9;
   numWeapons = 2;
   minDrag = 25;
   maxSteeringAngle = 4;
   maxForwardSpeed = 167;
   jetForce = 2500;
   vertThrustMultiple = 4.0;
   jetEnergyDrain = 1.8;
   minMountDist = 6;
   targetNameTag = 'Quad';
   targetTypeTag = 'Runner';
   trailEmitter = QuadRunnerContrail;
   observeParameters = "1 12 12";
   shieldEffectScale = "1.1 1.1 1.1";
   max[MissileLauncherAmmo] = 8;
};

datablock FlyingVehicleData(QuadRunnerTwo) : ScoutFlyer
{
   shapeFile = "quad_runner2.dts";
   explosion = LargeAirVehicleExplosion;
   debrisShapeName = "quad_runner_debris.dts";
   maxDamage = 3.0;
   destroyedLevel = 3.0;
   energyPerDamagePoint = 140;
   rechargeRate = 0.9;
   numWeapons = 2;
   minDrag = 25;
   maxSteeringAngle = 4;
   maxForwardSpeed = 167;
   jetForce = 2500;
   jetEnergyDrain = 1.8;
   vertThrustMultiple = 4.0;
   minMountDist = 6;
   targetNameTag = 'Quad';
   targetTypeTag = 'Runner';
   trailEmitter = QuadRunnerTwoContrail;
   observeParameters = "1 12 12";
   shieldEffectScale = "1.1 1.1 1.1";
   max[MissileLauncherAmmo] = 8;
};

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(QuadRunnerMissileImage)
{
   className = WeaponImage;
   shapeFile = "weapon_energy_vehicle.dts";
   item = MissileLauncher;
   ammo = MissileLauncherAmmo;
   projectile = TurretMissile;
   projectileType = SeekerProjectile;

   mountPoint = 10;
   offset = "0 -0.6 -0.15"; // L/R - F/B - T/B

   fireTimeout = 125;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   
   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateEmitterTime[3] = 0.2;
   stateSound[3] = MissileFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 3.2;
   stateAllowImageChange[4] = false;
   stateSound[4] = MissileReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6] = "DryFire";
   stateSound[6] = ShrikeBlasterDryFireSound;
   stateTimeoutValue[6] = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

datablock ShapeBaseImageData(QuadBlasterPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   item = Chaingun;
   ammo = ChaingunAmmo;
   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
   projectileSpread = 1.0 / 1000.0;

   mountPoint = 10;
   offset = "5.5 +8 -3";

   usesEnergy = true;
   useMountEnergy = true;
   minEnergy = 4;
   fireEnergy = 4;
   fireTimeout = 125;

   stateName[0] = "Activate";
   stateSequence[0] = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0] = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0] = "NoAmmo";

   stateName[1] = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "NoAmmo";
   stateTransitionOnAmmo[2] = "Ready";
   stateSpinThread[2] = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";

   stateName[3] = "Spinup";
   stateSpinThread[3] = SpinUp;
   stateTimeoutValue[3] = 0.01;
   stateWaitForTimeout[3] = false;
   stateTransitionOnTimeout[3] = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   stateName[4] = "Fire";
   stateSpinThread[4] = FullSpeed;
   stateRecoil[4] = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4] = "onFire";
   stateFire[4] = true;
   stateSound[4] = ShrikeBlasterFire;
   stateTimeoutValue[4] = 0.25;
   stateTransitionOnTimeout[4] = "checkState";

   stateName[5] = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5] = 0.01;
   stateWaitForTimeout[5] = false;
   stateTransitionOnTimeout[5] = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";

   stateName[6] = "EmptySpindown";
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6] = "Ready";
   stateTimeoutValue[6] = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";

   stateName[7] = "DryFire";
   stateSound[7] = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7] = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8] = "EmptySpindown";
   stateTimeoutValue[8] = 0.01;
   stateTransitionOnTimeout[8] = "ready";
};

datablock ShapeBaseImageData(QuadBlasterImage) : QuadBlasterPairImage
{
   offset = "-5.5 +8 -3";
   stateScript[3] = "onTriggerDown";
   stateScript[5] = "onTriggerUp";
   stateScript[6] = "onTriggerUp";
};

datablock ShapeBaseImageData(QuadBlasterThreeImage) : QuadBlasterPairImage
{
   offset = "5.5 +8 8";
};

datablock ShapeBaseImageData(QuadBlasterFourImage) : QuadBlasterPairImage
{
   offset = "-5.5 +8 8";
   stateScript[3] = "onTriggerDown";
   stateScript[5] = "onTriggerUp";
   stateScript[6] = "onTriggerUp";
};

datablock ShapeBaseImageData(QuadLockingParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = TurretMissile;
   projectileType = SeekerProjectile;
   isSeeker = true;
   seekRadius = 550;
   maxSeekAngle = 22;
   seekTime = 0.5;
   minSeekHeat = 0.6;
   minTargetingDistance = 25;
   useTargetAudio = true;
};

//**************************************************************
// QUAD RUNNER FUNCTIONS
//**************************************************************

function QuadRunner::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(QuadBlasterImage, 2);
   %obj.mountImage(QuadBlasterPairImage, 3);
   %obj.mountImage(QuadBlasterThreeImage, 4);
   %obj.mountImage(QuadBlasterFourImage, 5);
   %obj.mountImage(QuadRunnerMissileImage, 6);
   %obj.selectedWeapon = 1;
   %obj.nextWeaponFire = 2;
   %obj.schedule(5500, "playThread", $ActivateThread, "activate");
}

function QuadRunnerTwo::onAdd(%this, %obj)
{
   QuadRunner::onAdd(%this, %obj);
}

function QuadRunner::playerMounted(%data, %obj, %player, %node)
{
   %ammoAmt = %player.inv[MissileLauncherAmmo];
   if(%ammoAmt)
      %obj.incInventory(MissileLauncherAmmo, %ammoAmt);

   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   %obj.selectedWeapon = 1;
   $numVWeapons = 2;
   commandToClient(%player.client, 'setVWeaponsHudActive', 1, %player.getObjectMount().getDatablock().getName());
   commandToClient(%player.client, 'SetWeaponryVehicleKeys', true);
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function QuadRunnerTwo::playerMounted(%data, %obj, %player, %node)
{
   QuadRunner::playerMounted(%data, %obj, %player, %node);
}

function QuadRunner::playerDismounted(%data, %obj, %player)
{
   %obj.setInventory(MissileLauncherAmmo, 0);
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(4, false);
   %obj.setImageTrigger(5, false);
   %obj.setImageTrigger(6, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, true );
}

function QuadRunnerTwo::playerDismounted(%data, %obj, %player)
{
   QuadRunner::playerDismounted(%data, %obj, %player);
}

function QuadRunner::onTrigger(%data, %obj, %trigger, %state)
{
   %player = %obj.getMountNodeObject(0);
   if(%trigger == 0)
   {
      switch (%state)
      {
         case 0:
            %obj.fireWeapon = false;
            %obj.setImageTrigger(2, false);
            %obj.setImageTrigger(3, false);
            %obj.setImageTrigger(4, false);
            %obj.setImageTrigger(5, false);
            %obj.setImageTrigger(6, false);

         case 1:
            %obj.fireWeapon = true;
            if(%obj.selectedWeapon == 1)
            {
               if(%obj.nextWeaponFire == 2)
               {
                  %obj.setImageTrigger(2, true);
                  %obj.setImageTrigger(3, false);
                  %obj.setImageTrigger(4, false);
                  %obj.setImageTrigger(5, false);
               }
               else if(%obj.nextWeaponFire == 3)
               {
                  %obj.setImageTrigger(2, false);
                  %obj.setImageTrigger(3, true);
                  %obj.setImageTrigger(4, false);
                  %obj.setImageTrigger(5, false);
               }
               else if(%obj.nextWeaponFire == 4)
               {
                  %obj.setImageTrigger(2, false);
                  %obj.setImageTrigger(3, false);
                  %obj.setImageTrigger(4, true);
                  %obj.setImageTrigger(5, false);
               }
               else if(%obj.nextWeaponFire == 5)
               {
                  %obj.setImageTrigger(2, false);
                  %obj.setImageTrigger(3, false);
                  %obj.setImageTrigger(4, false);
                  %obj.setImageTrigger(5, true);
               }
            }
            else
            {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, false);
               %obj.setImageTrigger(4, false);
               %obj.setImageTrigger(5, false);
               %obj.setImageTrigger(6, true);
            }
      }
   }
   else if(%trigger == 4)
   {
      switch (%state)
      {
         case 0:
            if(%player.grenTimer == 0)
               return;
            else
            {
               %player.use(Grenade);
               %player.grenTimer = 0;
            }

         case 1:
            %player.grenTimer = 1;
      }
   }
   else if (%trigger == 5)
   {
      switch (%state)
      {
         case 0:
            if(%player.mineTimer == 0)
               return;
            else
            {
               %player.use(Mine);
               %player.mineTimer = 0;
            }

         case 1:
            %player.mineTimer = 1;
      }
   }
}

function QuadRunnerTwo::onTrigger(%data, %obj, %trigger, %state)
{
   QuadRunner::onTrigger(%data, %obj, %trigger, %state);
}

function QuadRunnerMissileImage::onFire(%data, %obj, %slot)
{
   %p = Parent::onFire(%data, %obj, %slot);
   %obj.getMountNodeObject(0).decInventory(%data.ammo, 1);
   MissileSet.add(%p);

   if (%obj.getControllingClient())
      %target = %obj.getLockedTarget();
   else
      %target = %obj.getTargetObject();

   if(%target)
      %p.setObjectTarget(%target);
   else if(%obj.isLocked())
      %p.setPositionTarget(%obj.getLockedPosition());
   else
      %p.setNoTarget();
}

function QuadBlasterImage::onFire(%data, %obj, %slot)
{
   Parent::onFire(%data, %obj, %slot);
   %obj.nextWeaponFire = 3;
   schedule(%data.fireTimeout, 0, "nextBlasterFire", %obj);
}

function QuadBlasterPairImage::onFire(%data, %obj, %slot)
{
   Parent::onFire(%data, %obj, %slot);
   %obj.nextWeaponFire = 4;
   schedule(%data.fireTimeout, 0, "nextBlasterFire", %obj);
}

function QuadBlasterThreeImage::onFire(%data, %obj, %slot)
{
   Parent::onFire(%data, %obj, %slot);
   %obj.nextWeaponFire = 5;
   schedule(%data.fireTimeout, 0, "nextBlasterFire", %obj);
}

function QuadBlasterFourImage::onFire(%data, %obj, %slot)
{
   Parent::onFire(%data, %obj, %slot);
   %obj.nextWeaponFire = 2;
   schedule(%data.fireTimeout, 0, "nextBlasterFire", %obj);
}

function nextBlasterFire(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 2)
      {
         %obj.setImageTrigger(2, true);
         %obj.setImageTrigger(3, false);
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, false);
      }
      else if(%obj.nextWeaponFire == 3)
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, true);
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, false);
      }
      else if(%obj.nextWeaponFire == 4)
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, false);
         %obj.setImageTrigger(4, true);
         %obj.setImageTrigger(5, false);
      }
      else
      {
         %obj.setImageTrigger(2, false);
         %obj.setImageTrigger(3, false);
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, true);
      }
   }
   else
   {
      %obj.setImageTrigger(2, false);
      %obj.setImageTrigger(3, false);
      %obj.setImageTrigger(4, false);
      %obj.setImageTrigger(5, false);
   }
}

function QuadBlasterImage::onTriggerDown(%this, %obj, %slot) { }
function QuadBlasterImage::onTriggerUp(%this, %obj, %slot) { }
function QuadBlasterImage::onMount(%this, %obj, %slot) { }
function QuadBlasterPairImage::onMount(%this, %obj, %slot) { }
function QuadBlasterThreeImage::onMount(%this, %obj, %slot) { }
function QuadBlasterFourImage::onMount(%this, %obj, %slot) { }
function QuadBlasterImage::onUnmount(%this, %obj, %slot) { }
function QuadBlasterPairImage::onUnmount(%this, %obj, %slot) { }
function QuadBlasterThreeImage::onUnmount(%this, %obj, %slot) { }
function QuadBlasterFourImage::onUnmount(%this, %obj, %slot) { }
function QuadRunnerMissileImage::onMount(%this, %obj, %slot) { }
function QuadRunnerMissileImage::onUnmount(%this, %obj, %slot) { }

function QuadRunner::onDestroyed(%data, %obj, %prevState)
{
   if(%obj.lastPilot.lastVehicle == %obj)
      if(%obj.getMountNodeObject(0) == %obj.lastPilot)
         schedule(200, %obj.lastPilot, "scKillPilot", %obj.lastPilot, %obj.lastDamagedBy);

   Parent::onDestroyed(%data, %obj, %prevState);
}

function QuadRunnerTwo::onDestroyed(%data, %obj, %prevState)
{
   if(%obj.lastPilot.lastVehicle == %obj)
      if(%obj.getMountNodeObject(0) == %obj.lastPilot)
         schedule(200, %obj.lastPilot, "scKillPilot", %obj.lastPilot, %obj.lastDamagedBy);

   Parent::onDestroyed(%data, %obj, %prevState);
}

function scKillPilot(%player, %source)
{
   if(isObject(%player) && %player.getState() !$= "Dead")
      %player.damage(%source, %player.position, %player.getDatablock().maxDamage, $DamageType::Explosion);
}
